<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<itemFormativoEsercizio nomeDescrittivo="Contapezzi a infrarossi" identificatoreArgomento="ContapezziIR" prerequisiti="diode,digitalInput,digitalOutput,interrupt" tags="DigitalOutput,Base,DigitalInput,Interrupt" fondamentale="false" mdPblproblem="false" mdPblnewlearninggoal="false" versione="1">
    <mdprerequisitelist>Funzionamento di LED e fotodiodi</mdprerequisitelist>
    <mdprerequisitelist>Pulsante</mdprerequisitelist>
    <mdprerequisitelist>Interrupt</mdprerequisitelist>
    <mdcomponentlist>LED IR + resistore adeguato</mdcomponentlist>
    <mdcomponentlist>Fotodiodo IR</mdcomponentlist>
    <mdcomponentlist>display LCD</mdcomponentlist>
    <mdwhy>Monitorare un segnale continuo che si interrompe al verificarsi di un evento.</mdwhy>
    <mdexpectedresult>Contare il numero di oggetti che attraversa lo spazio monitorato e mostrare il numero sul display, se non si possiede il display inviare il numero sulla porta seriale.&#13;
Prevedere un pulsante per azzerare il contatore, quindi non fare affidamento sul solo reset della scheda di sviluppo.</mdexpectedresult>
    <mdextras>L'eventuale presenza di una telecamera ad infrarossi puntata in direzione del fotodiodo può impedire di rilevare l'interruzione della barriera, una soluzione è usare un segnale IR codificato, in modo da distinguerlo dai possibili disturbi.&#13;
Si può utilizzare la codifica dei telecomandi e un sensore apposito come il VS1838, per procedere in questo modo saranno necessarie due schede di sviluppo, una per generare il segnale IR con il codice scelto e l'altra per riceverlo, la scheda ricevente dovrà decodificare il segnale e considerare la barriera interrotta se non arriva il codice previsto.</mdextras>
    <mderraticbehavior>In caso di velocità del passaggio dell'oggetto troppo alta rispetto a quanto previsto nel software si potrebbero rilevare meno pezzi, in caso di velocità troppo bassa si potrebbe rilevare lo stesso pezzo più volte.</mderraticbehavior>
    <mdcommonerrors>In caso d'uso di un sensore VS1838 senza resistore di pullup integrato, dimenticare di aggiungerlo.</mdcommonerrors>
    <mdlessonlearned>Dualismo polling-interrupt.&#13;
Espansione: Interferenze ambientali e azioni correttive.</mdlessonlearned>
    <mdsolution>Per il rilevamento è necessario un modulo già pronto con il fotodiodo ed il necessario ad amplificare il segnale (OpAmp), da collegare seguendo le indicazioni del produttore.&#13;
Per la fonte di raggi infrarossi collegare un LED IR con il resistore adeguato all'alimentazione, in modo che sia sempre acceso.</mdsolution>
    <mdpbldetails></mdpbldetails>
</itemFormativoEsercizio>
